# Import defines and errors
from .defines import *
from .error import *

SUPPORT_GL = False
SUPPORT_HDMIIN = False

from .sysinfo import SysInfo
cmp = SysInfo().compatible()

if cmp.find('rockchip') < 0:
    print('Toybrick can NOT support in this platform.')
    raise EnvironmentError

if cmp.find('rk3399') >= 0:
    SUPPORT_GL = True
elif cmp.find('rk3568') >= 0:
    SUPPORT_GL = True
elif cmp.find('rk3588') >= 0:
    SUPPORT_GL = True
    SUPPORT_HDMIIN = True
elif cmp.find('rk1808') >= 0:
    pass
else:
    pass

# Import Supported Libraries
from . import buffer
from .buffer import GraphicBuffer, SoundBuffer, copy_from
from .display import Display, DrmDisplay
from .rtsp import RtspCapture, RtspWriter
from .pipe import PipeCapture
from .v4l2 import CameraCapture
from .file import FileCapture

try:
    from .rtmp import RtmpWriter
except ImportError:
    pass

try:
    from .multicast import MulticastCapture
except ImportError:
    pass

if SUPPORT_HDMIIN:
    from .hdmi import HdmiCapture

# TODO
version = 'Ver 0.6.3'
host = ''
license = 'Free Edition'
