from . import libpyfilereader
from .buffer import GraphicBuffer, SoundBuffer
from .defines import *
from .error import *


class FileCapture:
    def __init__(self, path, vformat, loop=True):
        loop = 1 if loop else 0
        self.instance = libpyfilereader.create(path, vformat, loop)
        self.error = 0

    def __del__(self):
        libpyfilereader.delete(self.instance)

    def read(self, width=0, height=0, gformat=FMT_RGB888):
        img = libpyfilereader.read(self.instance, width, height, gformat)
        if img is None:
            self.error = RET_TRY_AGAIN
            dst = None
        else:
            dst = GraphicBuffer(img)
        return self.error, dst

    # def reada(self, aformat=FMT_PCM):
    #     snd = libpyfilereader.reada(self.instance, aformat)
    #     dst = SoundBuffer(snd)
    #     return self.error, dst
