from . import libpyhdmicap
from .buffer import GraphicBuffer
from .defines import *
from .error import *


class HdmiCapture:
    def __init__(self, fps=60):
        self.instance = libpyhdmicap.create(fps)
        self.error = 0

    def __del__(self):
        libpyhdmicap.delete(self.instance)

    def read(self, width=0, height=0, gformat=FMT_RGB888):
        img = libpyhdmicap.read(self.instance, width, height, gformat)
        if img is None:
            self.error = RET_TRY_AGAIN
            dst = None
        else:
            dst = GraphicBuffer(img)
        return self.error, dst
