from . import libpymulticastclient
from .buffer import GraphicBuffer
from .defines import *
from .error import *


class MulticastCapture:
    def __init__(self, url, port):
        self.instance = libpymulticastclient.create(url, port)
        self.error = 0

    def __del__(self):
        libpymulticastclient.delete(self.instance)

    def read(self, width=0, height=0, gformat=FMT_RGB888):
        img = libpymulticastclient.read(self.instance, width, height, gformat)
        if img is None:
            self.error = RET_TRY_AGAIN
            dst = None
        else:
            dst = GraphicBuffer(img)
        return self.error, dst
