from . import libpypipereceiver
from .buffer import GraphicBuffer
from .defines import *
from .error import *
import threading


class PipeCapture(threading.Thread):
    def __init__(self, popen, format):
        threading.Thread.__init__(self)
        self.instance = libpypipereceiver.create()
        self.popen = popen
        self.format = format
        self.error = 0

    def __del__(self):
        libpypipereceiver.delete(self.instance)

    def __feed__(self, packet):
        return libpypipereceiver.feed(self.instance, self.format, packet)

    def read(self, width=0, height=0, gformat=FMT_RGB888):
        img = libpypipereceiver.read(self.instance, width, height, gformat)
        if img is None:
            self.error = RET_TRY_AGAIN
            dst = None
        else:
            dst = GraphicBuffer(img)
        return self.error, dst

    def run(self):
        print('Ready for receiving from pipe. ' + str(self.popen))
        while True:
            packet = self.popen.stdout.read(4096)
            self.__feed__(packet)
