from . import libpyv4l2cap
from .buffer import GraphicBuffer
from .defines import *
from .error import *


class CameraCapture:
    def __init__(self, id, width, height, fps=30):
        self.instance = libpyv4l2cap.create(id, width, height, fps)
        self.error = 0

    def __del__(self):
        libpyv4l2cap.delete(self.instance)

    def read(self, width=0, height=0, gformat=FMT_RGB888):
        img = libpyv4l2cap.read(self.instance, width, height, gformat)
        if img is None:
            self.error = RET_TRY_AGAIN
            dst = None
        else:
            dst = GraphicBuffer(img)
        return self.error, dst
